package cz.muni.fi.pb162.collections;

import java.util.List;

/**
 * Tato trida predstavuje registr ctenaru knihovny.
 * 
 * @author Radek Oslejsek
 * @version 2007-11-15
 */
public interface ReadersRegister
{
    /**
     * Metoda prida noveho ctenare. Ctenar muze byt registrovany pouze jednou.
     * 
     * @param reader ctenar
     * @return true pokud ctenar v registru doposud nebyl
     */
    boolean registerReader(Reader reader);
    
    /**
     * Metoda odstani ctenare z registru.
     * 
     * @param reader ctenar
     * @return true pokud ctenar v registru existoval
     */
    boolean unregisterReader(Reader reader);
    
    /**
     * Zjisti, jestli je ctenar v registru.
     * 
     * @param reader ctenar
     * @return true pokud byl ctenar v registru nalezen
     */
    boolean readerExists(Reader reader);

    /**
     * Vrati abecedne usporadany seznam jmen vsech ctenaru.
     * 
     * @return abecedne usporadany seznam jmen ctenaru
     */
    List<String> getSortedNames();    
}
